#!/usr/bin/env python3
import pandas

# chemin qui mène à votre répertoire de travail
PATH = "/DONNEES/Enseignement/2018-19/SNT/TPs-donnees/" # a modifier
# nom du fichier csv
fname = "2019-SNT-Donnees-PollutionA.csv"

# on rappatrie les données du csv dans la variable donnees.
donnees = pandas.read_csv(PATH+fname, sep=";")

## commandes à faire dans le shell
donnees.columns.values
donnees.info()
donnees.loc[:5,:]
donnees.loc[:5,['polluant','Val Mesuree']]
##

# on ne garde que les colonnes 'polluant' et 'Val Mesuree'
dTronquees = donnees.loc[:,['polluant', 'Val Mesuree']]

for e in dTronquees.values :
    print(e)

## Traitement pour NO2
## sélection des mesures de NO2
dNO2 = []                   # au départ, aucune mesure n'a été gardée
for e in dTronquees.values :        # toutes les mesures sont parcourues
    if e[0]=='NO2':         # si la mesure concerne le NO2
        dNO2.append(e[1])   # on garde la valeur mesuree

## calcul de la moyenne
moyenne = 0
for e in dNO2:      # on parcourt toute la liste des valeurs de mesure de NO2
    moyenne = moyenne + e       # somme des mesures
moyenne = moyenne / len(dNO2)   # division par le nombre total de mesures
print(f"La moyenne NO2 vaut {moyenne:.3f}.")    # affichage de la moyenne au millième

## decompte du nombre de mesures supérieures à la moyenne
nbSup = 0
for e in dNO2 :   # on parcourt toute la liste des valeurs de mesure de NO2   
    if e > moyenne :        # si la mesure est supérieure à la moyenne
        nbSup = nbSup+1     # on ajoute 1 au décompte
print(f"Le nombre de mesures NO2 supérieures à la moyenne est de {nbSup}.")

## fin du traitement pour NO2

## Traitement pour O3 / PM10 / PM2,5 / SO2
dO3, dPM10, dPM25, dSO2 = [] , [], [], []
for e in dTronquees.values : 
    if e[0]=='O3':
        dO3.append(e[1])
    elif e[0]=='PM10':
        dPM10.append(e[1])
    elif e[0]=='PM2.5':
        dPM25.append(e[1])
    elif e[0]=='SO2':
        dSO2.append(e[1])

moyenne = 0
for e in dO3:      
    moyenne = moyenne + e      
moyenne = moyenne / len(dO3)  
print(f"La moyenne O3 vaut {moyenne:.3f}.")

nbSup = 0
for e in dO3 : 
    if e > moyenne :   
        nbSup = nbSup+1
print(f"Le nombre de mesures O3 supérieures à la moyenne est de {nbSup}.")
## fin O3

moyenne = 0
for e in dPM10:      
    moyenne = moyenne + e      
moyenne = moyenne / len(dPM10)  
print(f"La moyenne PM10 vaut {moyenne:.3f}.")
nbSup = 0
for e in dPM10 : 
    if e > moyenne :   
        nbSup = nbSup+1
print(f"Le nombre de mesures PM10 supérieures à la moyenne est de {nbSup}.")
## fin PM10

moyenne = 0
for e in dPM25:      
    moyenne = moyenne + e      
moyenne = moyenne / len(dPM25)  
print(f"La moyenne PM2,5 vaut {moyenne:.3f}.")
nbSup = 0
for e in dPM25 : 
    if e > moyenne :   
        nbSup = nbSup+1
print(f"Le nombre de mesures PM2,5 supérieures à la moyenne est de {nbSup}.")
## fin PM2,5

moyenne = 0
for e in dSO2:      
    moyenne = moyenne + e      
moyenne = moyenne / len(dSO2)  
print(f"La moyenne SO2 vaut {moyenne:.3f}.")
nbSup = 0
for e in dSO2 : 
    if e > moyenne :   
        nbSup = nbSup+1
print(f"Le nombre de mesures SO2 supérieures à la moyenne est de {nbSup}.")

## fin du traitement pour O3 / PM10 / PM2,5 / SO2

## approfondissement avec des fonctions
def traitement(dataTronquees, polluant):
    dPolluant = []
    for e in dataTronquees.values :
        if e[0]==polluant :
            dPolluant.append(e[1])
    moyenne = 0
    for e in dPolluant :
        moyenne = moyenne + e
    moyenne = moyenne / len(dPolluant)
    nbSup = 0
    for e in dPolluant :
        if e>moyenne :
            nbSup = nbSup + 1
    print(f"La moyenne {polluant} vaut {moyenne:.3f}.")
    print(f"Le nombre de mesures {polluant} supérieures à la moyenne est de {nbSup}.")

## appel :
# traitement(dTronquees, "O3")

# a proscrire : donnees.sort_values(by='polluant').loc[:3,['polluant', 'Val Mesuree']].groupby(by='polluant').mean()

# end of file '2019-Donnees-PollutionA-corrige.py'